;**********************************************************************
;Filename:		INC_LCD_Init_8_bit.inc	 
;Date:			Sept 14, 2010
;File Version:	1.00
;Author:		
;Objective:		Set up LCD in 8 bit mode and write to LCD
;Notes:		
;**********************************************************************
;Initialized LCD in 8 bit mode
LCD_not_Initialized
			BCF E_Control			;set up pic ports and pins
			BCF RS_Control
			BCF RW_Control	;XXXXXXXXXXXXXX remove if not needed, but can be left in XXXXXXXXXXXXXXX
			BSF STATUS, RP0			;bank 1
			BCF E_Control
			BCF RS_Control
			BCF RW_Control	;XXXXXXXXXXXXXX remove if not needed, but can be left in XXXXXXXXXXXXXXXX	
			CLRF  LCD_Data_Port		;set port for output b'0000000'
			BCF STATUS, RP0			;bank 0
			
			LCD_MS_Delay_MAC .15000	;15ms, just a small LCD power up delay
			
			;send 0x03 b'0000 0011"	three times									
						
			MOVLW 0x33				;b'0011 0011'
			MOVWF LCD_Temp_Chr
			CALL Write_Data			
			
			LCD_MS_Delay_MAC .5000	;5ms
					
			MOVLW 0x33				; b'0011 0011'
			MOVWF LCD_Temp_Chr
			CALL Write_Data			
			
			LCD_US_Delay_MAC .100	;100us
						
			MOVLW 0x33				;b'0011 0011'
			MOVWF LCD_Temp_Chr
			CALL Write_Data			
		
			LCD_US_Delay_MAC .100	;100us
		
											;    4 bit mode, 2 line             8 bit mode, 2 line
			MOVLW 0x38				;0x28 = b'0 0 1 0  1 0 x x'    	0x38 = b'0 0 1 1  1 0 x x'
			MOVWF LCD_Temp_Chr		;         0 0 1 DL N F x x               0 0 1 DL N F x x
			CALL LCD_Write			;DL=0 4 bit, DL=1 8 bit\N=0 1 line, N=1 2 or more lines\F=1 5x10 dots, F=0: 5x8 dots
									;The number of display lines and character font cannot be changed after this point.
								
			
			;any standard command after this point
			MOVLW 0x0c				;b'00001100'
			MOVWF LCD_Temp_Chr
			CALL LCD_Write			;screen on, cursor and blink off
					
			MOVLW 0x06				;b'00000110'
			MOVWF LCD_Temp_Chr
			CALL LCD_Write			;auto increment Cursor
			
			BSF LCD_Flag, LCD_Initialize_bit	;LCD Initialized, set bit
			RETURN
			
;******************************************************************************************
; 8 bit write
LCD_Get_Char_Write
			LCD_MS_Delay_MAC .2000	;2 ms, time between RS E and next RS E
			MOVF LCD_Chr_temp, W	;keep a copy
			MOVWF LCD_Temp_Chr		;extra swap  just to slow things down
			
LCD_Write	CALL Write_Data			;send high nibble
			RETURN					;exit programand get next write/command char
			
						
Write_Data	BSF E_Control			;************start write cycle
			movf LCD_Temp_Chr, w 
			nop
			MOVWF LCD_Data_Port			;send data to LCD
			nop
			BCF E_Control			;***********stop write cycle
			RETURN
;******************************************************************************************

 
