;************************************************************************
;Filename:		INC_LCD_Macros.inc	 
;Date:			Sept 2, 2010
;File Version:	1.00
;Author:		
;Objective:		easy screen commands
;Notes:			don't put macros after skip if set or skip if cleared instuctions
;				can't jump over the macro lable, it jumps into the middle of the macro
;***********************************************************************
; *  tested
;LCD_Clear_screen_MAC				*0x01	b'00000001'
;LCD_Home_cursor_to_1st_line_MAC	*0x02	b'00000010'
;LCD_Auto_Decrement_Cursor_MAC		*0x04	b'00000100'
;LCD_Auto_Increment_Display_MAC		*0x05	b'00000101'
;LCD_Auto_Increment_Cursor_MAC		*0x06	b'00000110'
;LCD_Auto_Decrement_Display_MAC		*0x07	b'00000111'
;LCD_Screen_off_MAC					*0x08	b'00001000'
;LCD_Screen_on_MAC					*0x0c	b'00001100'
;LCD_Display_Blink_on_Cur_off_MAC	*0x0d	b'00001101'
;LCD_Display_Cur_on_Blink_off_MAC	*0x0e	b'00001110'
;LCD_Display_Cur_Blink_on_MAC		*0x0f	b'00001111'
;LCD_Cursor_left_MAC				*0x10	b'00010000'
;LCD_Cursor_right_MAC				*0x14	b'00010100'
;LCD_Move_screen_left_MAC			*0x18	b'00011000'
;LCD_Move_screen_right_MAC			*0x1c	b'00011100'
;LCD_Set_char_ram_MAC				*0x40	b'01000000'
;LCD_Screen_ram_MAC					*0x80	b'10000000'
;LCD_Home_cursor_to_2nd_line_MAC	*0xc0	b'11000000'
;LCD_Home_cursor_to_3rd_line_MAC	 0x94	b'10010000'
;LCD_Home_cursor_to_4th_line_MAC	 0xd4	b'11010100'
;
;								*  tested
;***********************************************************************
;clear screen move cursor to first line
LCD_Clear_screen_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x01
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************		
;move cursor to beginning of first line
LCD_Home_cursor_to_1st_line_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x02	
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;Auto Decrement Cursor
LCD_Auto_Decrement_Cursor_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x04
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;Auto Increment Display
LCD_Auto_Increment_Display_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x05
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;Auto Increment Cursor (default)
LCD_Auto_Increment_Cursor_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x06
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;Auto Decrement Display
LCD_Auto_Decrement_Display_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x07
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;screen off to save power
LCD_Screen_off_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x08
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;screen on, Cursor and Blink off (default)
LCD_Screen_on_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x0c
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;Display and Blink on, Cursor off
LCD_Display_Blink_on_Cur_off_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x0d
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;Display and Cursor on, Blink off
LCD_Display_Cur_on_Blink_off_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x0e
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;Display, Cursor, and Blink on
LCD_Display_Cur_Blink_on_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x0f
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;move cursor left one location
LCD_Cursor_left_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x10
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;move cursor right one location
LCD_Cursor_right_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x14
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;move display screen left one position
LCD_Move_screen_left_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x18
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;move display screen right one position
LCD_Move_screen_right_MAC MACRO
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x1c
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;for custom chacters
;character ram starts at 0x40 for 1st char
;	next char starts at 0x40 plus 8 bytes or 0x48
;ram runs from 0x40 to 0x7f = 0x80 bytes/addresses
;	16 chars x 8 bytes = 128 bytes = 0x80 bytes/addresses	
;LCD_Set_char_ram_MAC .0	;.0 for 1st char, .1 for next char, etc....
LCD_Set_char_ram_MAC MACRO Chr_Ram_location
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x40 + (Chr_Ram_location * 8)
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;screen ram location
;			 1st line starts at 0x00 or .0, (plus .20 for off sreen for 20 char screen)
;			 2nd line starts at 0x40 or .64, (plus .20 for off screen for 20 char screen)
;LCD_Screen_ram_MAC .0 ;.0 for 1st position, .1 for next position for 1st line
;LCD_Screen_ram_MAC .64;.64 for 1st position, .65 for next position for 2nd line
LCD_Screen_ram_MAC MACRO Screen_location
		movlw 0xfe
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x80 + Screen_location	;screen ram starts ae 0x80
		PAGESEL LCDPRT
		call LCDPRT
		ENDM
;***********************************************************************
;move cursor to beginning of second line
LCD_Home_cursor_to_2nd_line_MAC MACRO
		movlw 0xfe	
		PAGESEL LCDPRT	
		call LCDPRT
		movlw 0xc0	
		PAGESEL LCDPRT	
		call LCDPRT
		ENDM
;***********************************************************************
;move cursor to beginning of third line;***not tested**
;as near as I can tell the LCD is initialized in 2 line mode for this to work
LCD_Home_cursor_to_3rd_line_MAC MACRO
		movlw 0xfe	
		PAGESEL LCDPRT	
		call LCDPRT
		movlw 0x94	
		PAGESEL LCDPRT	
		call LCDPRT
		ENDM
;***********************************************************************
;move cursor to beginning of fourth line;***not tested**
;as near as I can tell the LCD is initialized in 2 line mode for this to work
LCD_Home_cursor_to_4th_line_MAC MACRO
		movlw 0xfe	
		PAGESEL LCDPRT	
		call LCDPRT
		movlw 0xd4	
		PAGESEL LCDPRT	
		call LCDPRT
		ENDM
;***********************************************************************
; delay macros for INC_LCD_xxxxxxxxxx.inc

LCD_US_Delay_MAC MACRO Lcd_time
		movlw Lcd_time
		PAGESEL LCD_Delay_us
		CALL LCD_Delay_us
		ENDM
		
LCD_MS_Delay_MAC MACRO Lcd_time
		movlw HIGH (Lcd_time)
		MOVWF LCD_Delay_H_byte
		movlw LOW (Lcd_time)
		PAGESEL LCD_Delay_ms
		CALL LCD_Delay_ms
		ENDM

			


