;************************************************************************
;Filename:		INC_LCD_Read_4_bit_L_nib.inc	 
;Date:			Sept 15, 2010
;File Version:	1.00
;Author:		
;Objective:		
;Notes:			call LCD_Read after sending the address, retrieve data in W
;***********************************************************************
			CBLOCK
				LCD_Read_temp ;holds data read from LCD_Data_port
			ENDC
;***********************************************************************
;is the LCD initialized
LCD_Read	BTFSC LCD_Flag, LCD_Initialize_bit	;test the bit
			GOTO LCD_Read_continue				;bit set, LCD Initialized
			CAll LCD_not_Initialized			;cleard, LCD not Initialized
;***********************************************************************
 ;set up the R/W pin and data port      		
LCD_Read_continue
			BSF STATUS, RP0	; go to bank 1
			BCF RW_Control	;make R/W pin an output
			MOVLW 0x0f		;b'00001111'
      		IORWF LCD_Data_Port, F	;set low nibble to inputs with out changing the high nibble
			BCF STATUS, RP0	; go to bank 0
;***********************************************************************    		
;read the data from the data port      
      
			CLRF LCD_Read_temp			;clear the temp reg
			BSF RS_Control				;pull R/S pin high for data reg 
			BSF RW_Control				;pull R/W pin high for read
			
			Call LCD_Read_nibble		;get the first nibble
			
			SWAPF LCD_Read_temp, F		;swap the nibbles in read temp for the next pass
			
      		CALL LCD_Read_nibble		;go back and get the second nibble
     
      		LCD_US_Delay_MAC .50		;delay between E and R/W
      		
      		;start the exit
      		BCF RW_Control		;pull R/W pin low for writes
      		
      		;set the port back to write
      		BSF STATUS, RP0			;bank 1
      		MOVLW 0xf0				;set port back to low nibble outputs for writes b'xxxx0000'
			ANDWF LCD_Data_Port, F		;don't change the other nibble so it can be used some place else
			BCF STATUS, RP0			;bank 0
          		
          	;SWAPF LCD_Read_temp, F	;swap the nibbles to get the correct char so that 0x84 = 0x48 ascii	
          			
      		MOVF LCD_Read_temp, W	;put char temp in w and exit program
      		RETURN					;can also get data from LCD_Read_temp before next read

;************************************************************************* 
;read the port     
LCD_Read_nibble
			BSF E_Control			;pull E high to start the read
      		NOP
      		MOVLW 0x0f
      		ANDWF LCD_Data_Port, W		;put the nibble in w and clear the high nibble
      		IORWF LCD_Read_temp, F	;put the nibble in char temp without effecting the other nibble
      		BCF E_Control			;pull E low to stop the read
      		RETURN
