;************************************************************************
;Filename:		INC_LCD_Read_8_bit.inc	 
;Date:			Sept 15, 2010
;File Version:	1.00
;Author:		
;Objective:		
;Notes:			call LCD_Read after sending the address, retrieve data in W
;***********************************************************************
			CBLOCK
					LCD_Read_temp
     		ENDC
;*********************************************************************** 
;is the LCD initialized
LCD_Read	BTFSC LCD_Flag, LCD_Initialize_bit	;test the bit
			GOTO LCD_Read_continue				;bit set, LCD Initialized
			CAll LCD_not_Initialized			;cleared, LCD not Initialized
;***********************************************************************
;set up the R/W pin and data port      		
LCD_Read_continue
			BSF STATUS, RP0	; go to bank 1
			BCF RW_Control	;make R/W pin an output
			MOVLW 0xff
      		MOVWF LCD_Data_Port	;set data port to inputs
			BCF STATUS, RP0	; go to bank 0
;*********************************************************************** 		
;read the data from the data port			
			BSF RS_Control	;pull R/S pin high for data reg 
			BSF RW_Control	;pull R/W pin high for read
			;************start the read************
			BSF E_Control	;pull E pin high
			NOP
			NOP
			MOVF LCD_Data_Port, W	;move data to W
			MOVWF LCD_Read_temp	;save data 
			BCF E_Control	;pull E low
     		;*************end the read*************
     		
     		LCD_US_Delay_MAC .50	;delay beween E and R/W
     					
     		;start the exit
     		BCF RW_Control		;pull R/W pin low for writes
     	     		
     		BSF STATUS, RP0		; go to bank 1
     		MOVLW 0x00 			;set data port back to outputs
     		MOVWF LCD_Data_Port
     		BCF STATUS, RP0		; go to bank 0
     				
		
      		MOVF LCD_Read_temp, W	;move data from read temp to W
      		;NOTE:can retrieve data from LCD_Read_temp before next read
      		RETURN		;exit with data in W
