;**********************************************************************
;Filename:		INC_Macros_002,inc	 
;Date:			September 15, 2010
;File Version:	3.00
;Author:		
;Objective:		make programing faster/easier to read
;Notes:	      	don't put macros after skip if set or skip if cleared instuctions
;				can't jump over the macro lable, it jumps into the middle of the macro
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;				PAUSE MACROS
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;MS_Pause_MAC .5000	       ;use the dot for decimal, .5000 for 5000ms	
MS_Pause_MAC MACRO Delay	
        movlw HIGH (Delay)
        movwf M_High_Byte	;varify times with the STOP WATCH
        movlw LOW (Delay)
        movwf M_Low_Byte
        PAGESEL MPAUSE
        call MPAUSE  
        ENDM

;US_Pause_MAC .5000	      ;use the dot for decimal, .5000 for 5000us/5ms
US_Pause_MAC MACRO Delay	
        movlw HIGH (Delay)
        movwf U_High_Byte
        movlw LOW (Delay)
        movwf U_Low_Byte
        PAGESEL UPAUSE
        call UPAUSE  
        ENDM
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;				A MACRO
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX		
;Swap_Reg_W_MAC X_reg
; replace X_reg with the register which containes the data
;  which you want to swap W with
Swap_Reg_W_MAC MACRO S_Reg
		XORWF S_Reg, W
		XORWF S_Reg, F
		XORWF S_Reg, W
		ENDM 
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;				TABLE PRINT DELAY MACROS
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;Print_table_MAC TextName
;replace TextName with the label of the text string you wish to print
Print_table_MAC MACRO TextPrint
		MOVLW	LOW(TextPrint)	
		MOVWF	Text_Pointer_L			;NO DELAY
		MOVLW	HIGH(TextPrint)
		MOVWF	Text_Pointer_H
		PAGESEL Table_Print
		CALL	Table_Print
		ENDM
		
;Print_table_With_delay_1_MAC
;replace TextName with the label of the text string you wish to print
Print_table_delay_1_MAC MACRO TextPrint
		MOVLW	LOW(TextPrint)	
		MOVWF	Text_Pointer_L
		MOVLW	HIGH(TextPrint)
		MOVWF	Text_Pointer_H
		BSF 	LCD_Flag, Table_Print_delay_1
		PAGESEL Table_Print
		CALL	Table_Print
		BCF		LCD_Flag, Table_Print_delay_1
		ENDM		

;Print_table_With_delay_2_MAC
;replace TextName with the label of the text string you wish to print
Print_table_delay_2_MAC MACRO TextPrint
		MOVLW	LOW(TextPrint)	
		MOVWF	Text_Pointer_L
		MOVLW	HIGH(TextPrint)
		MOVWF	Text_Pointer_H
		BSF 	LCD_Flag, Table_Print_delay_2
		PAGESEL Table_Print
		CALL	Table_Print
		BCF		LCD_Flag, Table_Print_delay_2
		ENDM	

;Print_table_With_delay_3_MAC
;replace TextName with the label of the text string you wish to print
Print_table_delay_3_MAC MACRO TextPrint
		MOVLW	LOW(TextPrint)	
		MOVWF	Text_Pointer_L
		MOVLW	HIGH(TextPrint)
		MOVWF	Text_Pointer_H
		BSF 	LCD_Flag, Table_Print_delay_3
		PAGESEL Table_Print
		CALL	Table_Print
		BCF		LCD_Flag, Table_Print_delay_3
		ENDM
		
;Print_table_With_delay_4_MAC
;replace TextName with the label of the text string you wish to print
Print_table_delay_4_MAC MACRO TextPrint
		MOVLW	LOW(TextPrint)	
		MOVWF	Text_Pointer_L
		MOVLW	HIGH(TextPrint)
		MOVWF	Text_Pointer_H
		BSF 	LCD_Flag, Table_Print_delay_4
		PAGESEL Table_Print
		CALL	Table_Print
		BCF		LCD_Flag, Table_Print_delay_4
		ENDM
		
;Print_table_With_delay_5_MAC
;replace TextName with the label of the text string you wish to print
Print_table_delay_5_MAC MACRO TextPrint
		MOVLW	LOW(TextPrint)	
		MOVWF	Text_Pointer_L
		MOVLW	HIGH(TextPrint)
		MOVWF	Text_Pointer_H
		BSF 	LCD_Flag, Table_Print_delay_5
		PAGESEL Table_Print
		CALL	Table_Print
		BCF		LCD_Flag, Table_Print_delay_5
		ENDM
		
;Print_table_With_delay_6_MAC
;replace TextName with the label of the text string you wish to print
Print_table_delay_6_MAC MACRO TextPrint
		MOVLW	LOW(TextPrint)	
		MOVWF	Text_Pointer_L
		MOVLW	HIGH(TextPrint)
		MOVWF	Text_Pointer_H
		BSF 	LCD_Flag, Table_Print_delay_6
		PAGESEL Table_Print
		CALL	Table_Print
		BCF		LCD_Flag, Table_Print_delay_6
		ENDM										
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;				DATA TABLE MACRO
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;replace Data_lable with the label of the data string
;replace Data_byte_counter01 with number of bytes to be read
;replace Data_Table_sub_routine with the name of the routine that the data is sent to
;Data_table_MAC Data_string_byte, .11, Print_data_to_screen
Data_table_MAC MACRO Data_lable, Data_byte_number, Data_Table_sub_routine
		#DEFINE Data_user Data_Table_sub_routine
		MOVLW	Data_byte_number
		MOVWF	Data_byte_counter
		MOVLW	LOW(Data_lable)	
		MOVWF	Data_Pointer_L		
		MOVLW	HIGH(Data_lable)
		MOVWF	Data_Pointer_H
				
		PAGESEL Data_Table					
		CALL	Data_Table
		ENDM		
