;******************************************************************************
;Filename:		INC_Set_up_16F877.inc	 
;Date:			August 15, 2010
;File Version:	1.00
;Author:		
;Objective:	    set up the chip	
;Notes:			got to set up the chip before you can use it.
;				write this to get as much stuff out of the data sheet as you can
;				load bit patterns for final version to save memory 
;				go into MPLAB and get a COPY of the file for your chip that you
;				put in the DIRECTIVES section in the .ASM file ie..... #INCLUDE p16f877.inc.
;				and put that some place that you can get to
;				
;				It containes what you need here. Some data sheets have spelling
;				errors. 
;*****************************************************************************
; Call Setup
Set_up
		BANKSEL PORTA				;on a BANKSEL use a label that is only in that
		CLRF FSR					;bank or you might not have access to the other
		CLRF PORTA					;lables in this list, like portb may not work
		CLRF PORTB					;because it might be in two different banks
		CLRF PORTC
		CLRF PORTD					;clear strange data in ports
		CLRF PORTE
		MOVLW b'00000000'			;gie off, interrupts off
		movwf INTCON
		CLRF PIR1					;clear peripheral interrupts flags
		CLRF PIR2					;clear peripheral interrutps flags
		bcf ADCON0, ADON			;turn off ADC					
	
		BANKSEL TRISA
		bsf OPTION_REG, NOT_RBPU	;disable pull_ups
		bsf OPTION_REG, INTEDG		;interrupt on rising RBO
		bcf OPTION_REG, T0CS		;TRMO clock source set to internal
		bcf OPTION_REG, T0SE		;increment RA4/T0CKl on low to high
		bcf OPTION_REG, PSA			;set prescaler to TRMO
		bsf OPTION_REG, PS0			;set prescaler
		bsf OPTION_REG, PS1
		bsf OPTION_REG, PS2
									;no changes needed for th LCD
		movlw b'00000'
			movwf	TRISA				;porta set for outputs
		movlw b'00000001'
			movwf	TRISB				;portb set for outputs, BO as input for interrupt
		movlw b'10110000'			
			movwf	TRISC				;portc set for I/O, C7 as input, C6 as output for RS232
		movlw b'00000000'	
 			movwf	TRISD				;portd set for outputs
		movlw b'111'
			movwf	TRISE				;porte set for inputs
		CLRF PIE1					;disable peripheral interrupts
		CLRF PIE2					;disable peripheral interrupts
		MOVLW	b'00000111'			;set PORTA/E as digital I/O
		MOVWF	ADCON1
		
		BANKSEL PORTA
		RETURN

