;******************************************************************************
;Filename:		LCD_Demo0001.inc
;Date:			October 1, 2010
;File Version:	1.00
;Author:		
;Objective:		demostrate some LCD stuff
;Notes:	
;******************************************************************************
			CBLOCK
				Loop_count01
				Loop_count02
			ENDC
;******************************************************************************

LCD_DEMO001
		bcf LED		;just a debugging technique
		
		
		call Some_basic_stuff				;started out with a bunch of PAGESEL's
		call Ascii_table					;up here before I started ending the routines
		call Some_scrolling					;with a PAGESEL
		call Flashing_chars
		call Define_single_custom_char
		call Print_some_binary_stuff
		call Table_with_delay
	
		
		;goto LCD_DEMO
		RETURN   ;return to .asm listing
;******************************************************************************
;test the table delays
Table_with_delay
		LCD_Clear_screen_MAC
		Print_table_delay_1_MAC Text_Hello_World
		MS_Pause_MAC .2000
		LCD_Clear_screen_MAC
		PAGESEL Table_with_delay
		RETURN
;******************************************************************************
;print some binary stuff
Print_some_binary_stuff
		movlw .4					
		movwf Loop_count01
		
Loop_again_03
		MS_Pause_MAC .2000
		LCD_Clear_screen_MAC
		
		movlw 0xaa					
		PAGESEL LCD_Print_binary
		call LCD_Print_binary
				
		MS_Pause_MAC .2000
		LCD_Clear_screen_MAC
		;LCD_Home_cursor_to_2nd_line_MAC
		
		movlw 0x55
		PAGESEL LCD_Print_binary
		call LCD_Print_binary
		
		PAGESEL Print_some_binary_stuff ; PAGESEL waiting for when it returns
		decfsz Loop_count01, F				; to handle that goto
		goto Loop_again_03
		
		MS_Pause_MAC .2000
		LCD_Clear_screen_MAC
		PAGESEL Print_some_binary_stuff	;set up for next routine in this page. Any
		RETURN							;PAGESEL not setting up a call or goto to another
										;page can use
										;any lable that appears in this page.
;******************************************************************************		
;flashing custom chars
Flashing_chars
		PAGESEL	LCD_Clear_ram
		call LCD_Clear_ram
		PAGESEL	LCD_Custom_characters
		call LCD_Custom_characters			;load the new chars in ram
		LCD_Clear_screen_MAC
		Print_table_MAC Text_Custom_char   ;print all custom char ascii codes to 1st line
		MS_Pause_MAC .2000
				
		Print_table_MAC Text_Center_Hello	;has imbedded commands
		Print_table_MAC Text_Center_World
		
		movlw .50					
		movwf Loop_count01
Loop_again_02			
		Print_table_MAC Custom_char_00		;so do these
		Print_table_MAC Custom_char_01
		MS_Pause_MAC .100
		Print_table_MAC Custom_char_02
		Print_table_MAC Custom_char_03
		MS_Pause_MAC .100
		Print_table_MAC Custom_char_04
		Print_table_MAC Custom_char_05
		MS_Pause_MAC .100
		PAGESEL Flashing_chars		; PAGESEL waiting for when it returns
		decfsz Loop_count01, F		;   to set up that goto
		goto Loop_again_02
		RETURN
;******************************************************************************
;this is the basic method to send data to the LCD
Some_basic_stuff
		movlw "H"		;print H on first line
		PAGESEL LCDPRT
		call LCDPRT
				
		movlw 0xfe		;tell the program that the next data byte is a command
		PAGESEL LCDPRT
		call LCDPRT
		movlw 0x80 		;send command to
		PAGESEL LCDPRT
		call LCDPRT		;  point to first location on first line
		
		PAGESEL LCD_Read
	    CALL LCD_Read	;then read that screen location
	    
	    movlw 0xfe	
	    PAGESEL LCDPRT		
		call LCDPRT
		movlw 0xc0		;send command to
		PAGESEL LCDPRT
		call LCDPRT		;home curser to second line
		
	    MS_Pause_MAC .1000	;delay 1 sec to watch it print
	    	    
	    movf LCD_Read_temp, W	;get the char that was read
	    PAGESEL LCDPRT
	    call LCDPRT				; and print to second line
	    MS_Pause_MAC .2000
	    PAGESEL Some_basic_stuff	; PAGESEL waiting for when it returns
	    RETURN
	    
	    ;this has popped up several times
					;		if you issue a command and then issue a 2nd
					;		command then don't expect the 1st command to
					;		to be valid
		    
;******************************************************************************	    	    
;some scrolling
Some_scrolling
		MS_Pause_MAC .2000
		LCD_Clear_screen_MAC
	
		;LCD_Screen_ram_MAC .20			;this prints hello world off screen
		;Print_table_MAC Text_Hello
		;LCD_Screen_ram_MAC .84
		;Print_table_MAC Text_World
		
		Print_table_MAC Text_HW_off_screen  ;and this prints hello world off screen
		PAGESEL Some_scrolling			; PAGESEL to handel the call coming up
		
		movlw .5						;this calls the move left right 5 times
		movwf Loop_count01
Loop_again_01
		call Loop_move_left_right
		decfsz Loop_count01, F
		goto Loop_again_01
		RETURN					;exit routine
		
								;left right scroll	
Loop_move_left_right	
		movlw .20				;this is for a 20 char wide screen
		movwf Loop_count02		;20 times left
Loop_one
		LCD_Move_screen_left_MAC
		MS_Pause_MAC .10		;a small delay to slow it down
		PAGESEL Some_scrolling
		decfsz Loop_count02, F
		goto Loop_one
	
		MS_Pause_MAC .1000		;a little delay to read the screen
		PAGESEL Some_scrolling
		movlw .20				;this is for a 20 char wide screen
		movwf Loop_count02		;20 tmes right
Loop_two
		LCD_Move_screen_right_MAC
		MS_Pause_MAC .10		;a small delay to slow it down
		PAGESEL Some_scrolling
		decfsz Loop_count02, F
		goto Loop_two
	
		MS_Pause_MAC .800	;a little delay off screen
		PAGESEL Some_scrolling	;
		RETURN
;******************************************************************************
;this should be your ascii chars in the LCD,     some sort of loop would have been better
Ascii_table
		MS_Pause_MAC .1000
		LCD_Clear_screen_MAC
		Print_table_MAC Text_1_16_ascii
		LCD_Home_cursor_to_2nd_line_MAC
		Print_table_MAC Text_2_16_ascii
		PAGESEL Ascii_table
		CALL Ascii_code_delay_001
		Print_table_MAC Text_3_16_ascii
		LCD_Home_cursor_to_2nd_line_MAC
		Print_table_MAC Text_4_16_ascii
		PAGESEL Ascii_table
		CALL Ascii_code_delay_001
		Print_table_MAC Text_5_16_ascii
		LCD_Home_cursor_to_2nd_line_MAC
		Print_table_MAC Text_6_16_ascii
		PAGESEL Ascii_table
		CALL Ascii_code_delay_001
		Print_table_MAC Text_7_16_ascii
		LCD_Home_cursor_to_2nd_line_MAC
		Print_table_MAC Text_8_16_ascii
		PAGESEL Ascii_table
		CALL Ascii_code_delay_001		
		Print_table_MAC Text_9_16_ascii
		LCD_Home_cursor_to_2nd_line_MAC
		Print_table_MAC Text_10_16_ascii
		PAGESEL Ascii_table
		CALL Ascii_code_delay_001
		Print_table_MAC Text_11_16_ascii
		LCD_Home_cursor_to_2nd_line_MAC
		Print_table_MAC Text_12_16_ascii
		PAGESEL Ascii_table
		CALL Ascii_code_delay_001
		Print_table_MAC Text_13_16_ascii
		LCD_Home_cursor_to_2nd_line_MAC
		Print_table_MAC Text_14_16_ascii
		PAGESEL Ascii_table
		CALL Ascii_code_delay_001
		Print_table_MAC Text_15_16_ascii
		PAGESEL Ascii_table
		CALL Ascii_code_delay_001
		
		PAGESEL Ascii_table	; PAGESEL waiting for when it returns
		RETURN		;exit routine
		
Ascii_code_delay_001
		MS_Pause_MAC .3000
		LCD_Clear_screen_MAC		;PAGESEL not needed because the next instruction 
		RETURN						;is a macro which has the PAGESEL
	
;******************************************************************************
;define a single char. in this case the 7th char, ascii code 0x06
Define_single_custom_char
		LCD_Clear_screen_MAC
		Print_table_MAC Text_Custom_char  ;print all custom char ascii codes to 1st line
		MS_Pause_MAC .2000
		
		LCD_Set_char_ram_MAC .6			;a big 8 ;ascii code 0x06	
		movlw b'11111'
		PAGESEL LCDPRT
		call LCDPRT
		movlw b'10001'
		PAGESEL LCDPRT			
		call LCDPRT
		movlw b'10001'				;one thing to notice about this routine is that the
		PAGESEL LCDPRT
		call LCDPRT					;big 8 came up on the screen without reprinting
		movlw b'11111'				;it's ascii code
		PAGESEL LCDPRT
		call LCDPRT				
		movlw b'11111'
		PAGESEL LCDPRT
		call LCDPRT
		movlw b'10001'
		PAGESEL LCDPRT
		call LCDPRT
		movlw b'10001'
		PAGESEL LCDPRT
		call LCDPRT
		movlw b'11111'
		PAGESEL LCDPRT
		call LCDPRT
		LCD_Screen_on_MAC
	
		MS_Pause_MAC .5000
		LCD_Clear_screen_MAC
		PAGESEL Define_single_custom_char
		RETURN
;******************************************************************************


