;******************************************************************************
;Filename:		PIC_Compiler.asm	 
;Date:			August 29, 2010
;File Version:	"9000"
;Author:		BOY_I_HOPE_I_DIDN'T_FORGET_SOMETHING
;Objective:		geared toward the new-bee for project development
;Notes:			to make this easier to read go to EDIT / PROPERTIES / TEXT / CHOOSE COLORS
; 				and change the color for PREPROCESSOR DIRECTIVES
;
;				Put all files in one folder and create your project useing this .asm file
;				Use this file to set up the PIC
;				Use the INC_LCD_MAIN.inc to set up the LCD
;
;				To switch to another chip
;					Change the DIRECTIVES
;					Change the Assembler Constants, EQU's, DEFINES
;					Verify the VARABLE address in CBLOCK
;					Verify the INCLUDE files
;
;				If you are stuck with 2k of memory or less in your chip then
;				keep the ORG 0x00 and remove the other ORG's
;				To free up more memory go through all the listings and remove
;				the PAGSEL's. Of course keep a back up copy.
;				If you don't have a set up file	then use the one provided as a template and
;				add or remove what you need. If you don't have a clear ram then just 
;				clear the LCD_Flag
;****************************** DIRECTIVES *******************************
	ERRORLEVEL 0	, -302, -306
	#INCLUDE p16f877.inc
	__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_ON & _XT_OSC & _WRT_ENABLE_ON & _LVP_OFF & _DEBUG_OFF & _CPD_OFF

;****************** Assembler Constants, EQU's, DEFINES ***********************
		#DEFINE LED PORTD, 0x0 ;a debugging technique and to blink the LED

;****************************** VARABLES IN RAM *******************************
		CBLOCK	0x20		
			
		ENDC
;*****************************************************************************
; only include MACRO files here, they have to be read before the ORG
		#INCLUDE INC_Macros_002.inc
		#INCLUDE INC_LCD_Macros.inc	
;*****************************************************************************
		ORG 0x00		;need for 2k memory
		GOTO Initialize
;*****************************************************************************
		;ORG 0x04	; interrupt vector address
		;#INCLUDE INC_interrupt_handler.inc
;*****************************************************************************
;page 0 Include files, static files that don't change once written
		#INCLUDE INC_Set_up_16F877.inc		
		#INCLUDE INC_Clear_Ram_16F877.inc	;remove if you don't have one	
		;#INCLUDE INC_Pause_4mhz.inc		;for 4mhz clock
		#INCLUDE INC_Pause_20mhz.inc		;for 20mhz clock
		#INCLUDE INC_LCD_MAIN.inc			;if you don't have a LCD then remove
		#INCLUDE INC_LCD_Print_binary.inc	;if you don't have a LCD then remove
;*****************************************************************************
Initialize
		CALL Set_up
		CALL Clear_Ram    		;remove if you don't have one and clrf LCD_Flag	
		MS_Pause_MAC .500 		;delay for LCD ;if you don't have a LCD then remove
		call LCD_Clear_ram 		;if you don't have a LCD then remove
		LCD_Clear_screen_MAC	;if you don't have a LCD then remove
		PAGESEL Main
		goto Main			 
;*****************************************************************************
;page 1, main program, 
;dynamic files, files that change in size from project to project
;try not to put to much code here use a include file
					
		;ORG 0x800	;remove for 2k memory

Main 	
		call Blink_LED						
		call LCD_DEMO001	;if you don't have a LCD then remove		
	    call LCD_Demo0002	;if you don't have a LCD then remove
	
		bsf LED				;it got to the end
		PAGESEL Main		;got to set up that goto to this page
Self	goto Main
	
		#INCLUDE LCD_Demo0001.inc		;user code file ;if you don't have a LCD then remove
		#INCLUDE LCD_Demo0002.inc		;user code file ;if you don't have a LCD then remove
		#INCLUDE Demo_Blink_LED.inc
;*****************************************************************************
;page 2,  dynamic files

		;ORG 0x1000		;remove for 2k memory
		
;*****************************************************************************		
;page 3	Include files, dynamic, files that change in size from project to project
	
		;ORG 0x1800		;remove for 2k memory
		
		#INCLUDE INC_LCD_Custom_chrs.inc		;if you don't have a LCD then remove
		#INCLUDE INC_LCD_Print_from_table.inc  ;doesn't like page bounderies ;if you don't have a LCD then remove
		#INCLUDE INC_Data_table.inc				;if you don't have a LCD then remove
		
;if you have a routine that uses a dynamic buffer, place it at the end of this list.
;   so it won't over write your VARABLES in CBLOCK
;*************************************************************************
		END
;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;some notes on the PAGESEL and macros
;
;don't need a PAGESEL to call a macro if the PAGESEL is in the macro
;don't need a PAGESEL between macros for same reason as above
;if you call a routine in another page, then have a PAGESEL waiting for it when it returns
;     it's the returns that caused the most problems
;try to end your routines with a PAGESEL because as soon as it incounters
;		a goto or call in your new routine, you will have an unexpected
;		jump to somewhere
;
; BANKSEL and PAGESEL are macros, they insert code
; don't put macros after the bit test skip instructions because it can't jump over a
;  label, it jumps into the macro.


